package com.bcxin.tenant.domain.v5.services.commands;

import com.bcxin.Infrastructures.commands.CommandAbstract;
import com.bcxin.Infrastructures.enums.CredentialType;
import com.bcxin.Infrastructures.enums.MasterSlaveType;
import com.bcxin.Infrastructures.enums.TrueFalseStatus;
import lombok.Getter;

import java.util.Collection;

@Getter
public class SyncUserCommand extends CommandAbstract {
    private final String id;
    private final String name;
    private final String loginNo;
    private final String domainId;
    private final MasterSlaveType masterSlaveType;
    private final Collection<String> departmentIds;
    private final CredentialType credentialType;
    private final String credentialNumber;
    private final TrueFalseStatus isDomainAdmin;

    private final String telephone;

    public SyncUserCommand(String id, String name, String loginNo, String domainId,
                           MasterSlaveType masterSlaveType,
                           Collection<String> departmentIds,
                           CredentialType credentialType,
                           String credentialNumber,
                           TrueFalseStatus isDomainAdmin,
                           String telephone) {
        this.id = id;
        this.name = name;
        this.loginNo = loginNo;
        this.domainId = domainId;
        this.masterSlaveType = masterSlaveType;
        this.departmentIds = departmentIds;
        this.credentialType = credentialType;
        this.credentialNumber = credentialNumber;
        this.isDomainAdmin = isDomainAdmin;
        this.telephone = telephone;
    }

    public static SyncUserCommand create(String id, String name, String loginNo, String domainId,MasterSlaveType masterSlaveType,
                                         Collection<String> departmentIds,
                                         CredentialType credentialType,
                                         String credentialNumberr,
                                         TrueFalseStatus isDomainAdmin,
                                         String telephone) {
        return new SyncUserCommand(id, name, loginNo, domainId, masterSlaveType, departmentIds, credentialType, credentialNumberr, isDomainAdmin,telephone);
    }
}
